%define _name mirror

Name:           %{_name}-oss
Version:        1.0
Release:        4.1
Packager:       Paul Bernal <paul.bernal@cedia.org.ec>
Summary:        Plataforma para despliegue de un servidor mirror de OSS
Group:          Applications/Publishing
License:        WTFPL

URL:            https://mirror.cedia.org.ec/mirror-oss.html
Source0:        %{name}-%{version}.tar.gz

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch:      x86_64
Requires:       bc, psmisc
Requires:       epel-release, anku-release
Requires:       hiawatha >= 9.7
Requires:       xinetd, rsync, vsftpd
Requires:       munin, munin-node, webalizer
# Requires for iim script (CPAN)
Requires:       perl-JSON
# Requires for fedora & epel
Requires:       mirrormanager-client
Requires:       zsh

%description
Plataforma para despliegue de un servidor mirror de Software
de Código Abierto (OSS), con soporte para web, ftp y rsync.

%prep
%setup -qc %{name}-%{version}

%install
rm -rf $RPM_BUILD_ROOT
install -dm 755 $RPM_BUILD_ROOT%{_localstatedir}/www
cp -a . $RPM_BUILD_ROOT%{_localstatedir}/www
# Cron conf
install -dm 755 $RPM_BUILD_ROOT%{_sysconfdir}/cron.d
mv -f $RPM_BUILD_ROOT%{_localstatedir}/www/etc/cron.mirror $RPM_BUILD_ROOT%{_sysconfdir}/cron.d/mirror
# Hiawatha conf
install -dm 755 $RPM_BUILD_ROOT%{_sysconfdir}/hiawatha
mv -f $RPM_BUILD_ROOT%{_localstatedir}/www/etc/hiawatha.mirror $RPM_BUILD_ROOT%{_sysconfdir}/hiawatha/
# Rsyncd conf
mv -f $RPM_BUILD_ROOT%{_localstatedir}/www/etc/rsyncd.mirror $RPM_BUILD_ROOT%{_sysconfdir}/
mv -f $RPM_BUILD_ROOT%{_localstatedir}/www/etc/rsyncd.motd $RPM_BUILD_ROOT%{_sysconfdir}/
# Vsftpd conf
install -dm 755 $RPM_BUILD_ROOT%{_sysconfdir}/vsftpd
mv -f $RPM_BUILD_ROOT%{_localstatedir}/www/etc/vsftpd.mirror $RPM_BUILD_ROOT%{_sysconfdir}/vsftpd/
# Xinetd conf
install -dm 755 $RPM_BUILD_ROOT%{_sysconfdir}/xinetd.d
mv -f $RPM_BUILD_ROOT%{_localstatedir}/www/etc/xinetd.mirror $RPM_BUILD_ROOT%{_sysconfdir}/xinetd.d/rsync

%pre
# Create replica user/group (if not exists already)
getent group replica >/dev/null || groupadd -r replica
getent passwd replica >/dev/null || \
useradd -r -g replica -d %{_localstatedir}/www -s /bin/bash \
-c "Mirror Replicant User" replica

%post
echo "post var = ${1}" >> %{_localstatedir}/www/log/rpmbuild.log
if [ "$1" = "1" ]; then
  # Perform tasks to prepare for the initial installation
  # Preserve the original hiawatha conf file and link to ours
  cd %{_sysconfdir}/hiawatha/
  [ -f hiawatha.conf.orig ] || mv -f hiawatha.conf hiawatha.conf.orig
  [ -h hiawatha.conf ] || ln -sf hiawatha.mirror hiawatha.conf
  cd -
  # Preserve the original rsyncd conf file and link to ours
  cd %{_sysconfdir}/
  [ -f rsyncd.conf.orig ] || mv -f rsyncd.conf rsyncd.conf.orig
  [ -h rsyncd.conf ] || ln -sf rsyncd.mirror rsyncd.conf
  cd -
  # Preserve the original vsftpd conf file and link to ours
  cd %{_sysconfdir}/vsftpd/
  [ -f vsftpd.conf.orig ] || mv -f vsftpd.conf vsftpd.conf.orig
  [ -h vsftpd.conf ] || ln -sf vsftpd.mirror vsftpd.conf
  cd -
#elif [ "$1" = "2" ]; then
  # Perform whatever maintenance must occur before the upgrade begins
fi

%postun
echo "postun var = ${1}" >> %{_localstatedir}/www/log/rpmbuild.log
if [ "$1" = "0" ]; then
  # Perform tasks to prepare for the uninstallation
  # Restore the original hiawatha conf file
  mv -f %{_sysconfdir}/hiawatha/hiawatha.conf.orig %{_sysconfdir}/hiawatha/hiawatha.conf
  # Restore the original rsyncd conf file
  mv -f %{_sysconfdir}/rsyncd.conf.orig %{_sysconfdir}/rsyncd.conf
  # Restore the original vsftpd conf file
  mv -f %{_sysconfdir}/vsftpd/vsftpd.conf.orig %{_sysconfdir}/vsftpd/vsftpd.conf
#elif [ "$1" = "1" ]; then
  # Perform whatever maintenance must occur after the upgrade
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
#%doc README
%config(noreplace) %{_sysconfdir}/cron.d/%{_name}
%config(noreplace) %{_sysconfdir}/hiawatha/hiawatha.mirror
%config(noreplace) %{_sysconfdir}/rsyncd.mirror
%config(noreplace) %{_sysconfdir}/rsyncd.motd
%config(noreplace) %{_sysconfdir}/vsftpd/vsftpd.mirror
%config(noreplace) %{_sysconfdir}/xinetd.d/rsync
%defattr(-,replica,replica,-)
%{_localstatedir}/www/.bash_logout
%{_localstatedir}/www/.bash_profile
%{_localstatedir}/www/.bashrc
%{_localstatedir}/www/.zshrc
%config(noreplace) %{_localstatedir}/www/.config/quick-fedora-mirror.conf
%{_localstatedir}/www/bin
%{_localstatedir}/www/etc
%config(noreplace) %{_localstatedir}/www/etc/distros.lst
%{_localstatedir}/www/log
%{_localstatedir}/www/mirror
%config(noreplace) %{_localstatedir}/www/mirror/favicon.ico
%config(noreplace) %{_localstatedir}/www/mirror/home.css
%config(noreplace) %{_localstatedir}/www/mirror/home.xslt
%config(noreplace) %{_localstatedir}/www/mirror/mirror.css
%config(noreplace) %{_localstatedir}/www/mirror/mirror.xslt
%config(noreplace) %{_localstatedir}/www/mirror/robots.txt
%{_localstatedir}/www/tmp

%changelog
* Tue Mar 20 2018 Paul Bernal <paul.bernal@cedia-org.ec> - 1.0-4
- Added some files to %config(noreplace)
- Wrap %post & %postun with logic to run only on install/uninstall
* Wed Feb 28 2018 Paul Bernal <paul.bernal@cedia-org.ec> - 1.0-3
- Removed -%{release} from Source0 declaration
- Added perl-JSON on Requires
* Wed Jan 10 2018 Paul Bernal <paul.bernal@cedia-org.ec> - 1.0-2
- Added zsh & munin on Requires
* Wed Jan 10 2018 Paul Bernal <paul.bernal@cedia-org.ec> - 1.0-1
- Initial RPM release
